#ifndef __CAMERANODE_H__
#define __CAMERANODE_H__

/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <scene/Node.h>

namespace scene
{
	class Camera;

    /**
     * @brief
     * This is the camera node class.
     */
	class API_STATE CameraNode : public Node
	{
	public:
        /**
         * Constructor
         */
		CameraNode();

        /**
         * Destructor
         */
		virtual ~CameraNode();

        /**
         * Set the camera on the node
         *
		 * @param pCamera The camera object
         */
		void setCamera(Camera *pCamera);

        /**
         * Get the camera on the node
         *
		 * @return the camera
         */
		const Camera* getCamera() const;
		Camera* getCamera();

	private:
        /**
         * The camera object
         */
		Camera *_pCamera;
	};

#include <scene/CameraNode.inl>
}
#endif