#ifndef __COLORRGBA__
#define __COLORRGBA__

/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <util/Log.h>
#include <util/Object.h>

namespace scene
{
    /**
     * @brief
     * The ColorRGBA class.
     */
	class API_STATE ColorRGBA : public Object
	{
	public:
        /**
         * Predefined color property
         */
		static const ColorRGBA BLACK;
		static const ColorRGBA WHITE;
		static const ColorRGBA GRAY;

		/**
         * The R,G,B,A values
         */
		float32 r,g,b,a;

		/**
         * Constructor
         */
		ColorRGBA();

        /**
         * Constructor
		 *
		 * @param r The red value
		 * @param g The green value
		 * @param b The blue value
		 * @param a The alpha value
         */
		ColorRGBA(float32 r, float32 g, float32 b, float32 a);

		/**
		 * @see Object::toString()
		 */
		const char *toString(){return "class: ColorRGBA";}
	};

}

#endif