/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

inline void Light::setDirection(const math::Vector3f &direction)
{
	_direction = direction;
}

inline void Light::setAmbient(const ColorRGBA &ambient)
{
	_ambient = ambient;
}

inline void Light::setDiffuse(const ColorRGBA &diffuse)
{
	_diffuse = diffuse;
}

inline void Light::setSpecular(const ColorRGBA &specular)
{
	_specular = specular;
}

inline void Light::setLightType(E_LIGHT_TYPE eType)
{
	_eType = eType;
}

inline void Light::setSpotParams(float32 exponent, float32 cutOff)
{
	// exponent need to be no more than 180.0f
	// cutoff need to be no more than 90.0f
	_exponent = exponent;
	_cutOff = cutOff;
}

inline const math::Vector3f &Light::getDirection()
{
	return _direction;
}

inline const ColorRGBA &Light::getAmbient()
{
	return _ambient;
}

inline const ColorRGBA &Light::getDiffuse()
{
	return _diffuse;
}

inline const ColorRGBA &Light::getSpecular()
{
	return _specular;
}

inline Light::E_LIGHT_TYPE Light::getLightType()
{
	return _eType;
}

inline void Light::getSpotParams(float32 &exponent, float32 &cutOff)
{
	exponent = _exponent;
	cutOff = _cutOff;
}

inline void Light::setEnable(bool value)
{
	_enabled = value;
}

inline bool Light::isEnabled()
{
	return _enabled;
}

inline void Light::setLightNumber(uint32 number)
{
	_number = number;
}

inline uint32 Light::getLightNumber()
{
	return _number;
}
