/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

inline void Transformation::setTranslation(const math::Vector3f &translate)
{
	_translate = translate;
}

inline const math::Vector3f &Transformation::getTranslation()
{
	return _translate;
}

inline void Transformation::setRotation(float rotateAngle, const math::Vector3f &rotate)
{
	_rotateAngle = rotateAngle;
	_rotate = rotate;
}

inline void Transformation::getRotation(float &rotateAngle, math::Vector3f &rotate)
{
	rotateAngle = _rotateAngle;
	rotate = _rotate;
}

inline void Transformation::setScale(math::Vector3f scale)
{
	_scale = scale;
}

inline const math::Vector3f &Transformation::getScale()
{
	return _scale;
}

inline void Transformation::setTarget(const math::Vector3f &target)
{
	_target = target;
}

inline const math::Vector3f &Transformation::getTarget()
{
	return _target;
}

