#ifndef __CULLPROPERTY_H__
#define __CULLPROPERTY_H__

/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <scene/property/Property.h>

namespace scene
{
    /**
     * @brief
     * This is the Cull property class.
     */
	class API_STATE CullProperty : public Property
	{
	public:
		/**
		 * The Cull properties.
		 */
		enum E_CULL_TYPE
		{
			CT_FRONT = 0,
			CT_BACK
		};

		enum E_FACE_TYPE
		{
			FT_CLOCKWISE = 0,
			FT_COUNTERCLOCKWISE
		};

		/**
         * Constructor
         */
		CullProperty();

        /**
         * Destructor
         */
		virtual ~CullProperty(){}

        /**
         * Set the cull property
         *
		 * @param eValue The property value
         */
		void setCullType(E_CULL_TYPE eValue);

        /**
         * Get the cull property
         *
		 * @return The property
         */
		E_CULL_TYPE getCullType();

		/**
		 * @see Object::toString()
		 */
		const char * toString(){return "class: CullProperty";}

	private:
		/**
		 * The cull value
		 */
		E_CULL_TYPE _eValue;
	};

#include <scene/property/CullProperty.inl>
}

#endif