/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

inline void MaterialProperty::setEmissive(ColorRGBA &emissive)
{
	_emissive = emissive;
}

inline void MaterialProperty::setAmbient(ColorRGBA &ambient)
{
	_ambient = ambient;
}

inline void MaterialProperty::setDiffuse(ColorRGBA &diffuse)
{
	_diffuse = diffuse;
}

inline void MaterialProperty::setSpecular(ColorRGBA &specular)
{
	_specular = specular;
}

inline void MaterialProperty::setShininess(float32 shininess)
{
	_shininess = shininess;
}

inline void MaterialProperty::setAlphaValue(float32 value)
{
	_alphaValue = value;
}

inline const ColorRGBA &MaterialProperty::getEmissive()
{
	return _emissive;
}

inline const ColorRGBA &MaterialProperty::getAmbient()
{
	return _ambient;
}

inline const ColorRGBA &MaterialProperty::getDiffuse()
{
	return _diffuse;
}

inline const ColorRGBA &MaterialProperty::getSpecular()
{
	return _specular;
}

inline float32 MaterialProperty::getShininess()
{
	return _shininess;
}

inline float32 MaterialProperty::getAlphaValue()
{
	return _alphaValue;
}
