#ifndef DEFINE_H_
#define DEFINE_H_

/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

/**
 * @page config Configuration Instructions
 *
 * @section intro Details
 *
 * You could turn on the main features of Aika (Memory Leak Tracking and Stack Trace).
 * Go to the "Define.h" and turn ON:
 *
 * - MEMORY_LOG  (To tracking memory allocation)
 * - TRACE_LOG   (For Stack Trace)
 *
 */

#ifdef WIN32
	#if defined( __MINGW32__ )
		#define API_STATE
		#define API_PRIVATE_STATE
	#else
        #pragma warning (disable : 4251)

		#if defined( AK_DYN_EXPORT )
			#define API_STATE __declspec( dllexport )
			#define EXPIMP_TEMPLATE
		#else
			#define API_STATE __declspec( dllimport )
			#define EXPIMP_TEMPLATE extern
		#endif
	#endif
#endif

//------------------------------
// Defs
//------------------------------
#define ON  1
#define OFF 0

#if defined(AK_DEBUG)
#	define ASSERTION_LOG ON
#	define MEMORY_LOG	 ON
#	define TRACE_LOG	 ON
#else
#	define ASSERTION_LOG OFF
#	define MEMORY_LOG	 OFF
#	define TRACE_LOG	 OFF
#endif

#endif //DEFINE_H_
