/* Aika
*
* Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "helloworldApp.h"
#include <scene/Mesh.h>
#include <scene/MeshNode.h>

Demo::Demo() : AppFramework("Hello World Sample (using AppFramework)", 800, 600, false), _pCamera(NULL)
{
	Device::setDataPath("../media/");
}

void Demo::printFramerate()
{
	_mainRender->writeText(10, 14, "Aika");

	String strFrameRate = String::intToStr((int)getFrameRate());
	strFrameRate.concat(" fps");
	_mainRender->writeText(10, 13, strFrameRate.getChars());
}

void Demo::processInput()
{
	InputMap *input = InputMap::getInstance();

	if(input->verifyIfWasPressed(InputMap::KT_ESC))
	{
		quitApp();
	}
}

void Demo::onCreate()
{
	_scene.openScene("scene.aks");

	const CameraNode * cameraNode = (CameraNode*)_scene.getNodeByName("Camera");
	if(cameraNode)
	{
		_pCamera = (Camera*)cameraNode->getCamera();
		_pCamera->initialize();
	}

}

void Demo::onUpdate()
{
	static float incr = 0;
	incr+=0.01f;

	static float incr1 = 0;
	incr1 -= 0.1f;

	_scene.update();

	MeshNode *skyNode = (MeshNode*)_scene.getNodeByName("Skydome");
	if(skyNode)
		skyNode->getMesh()->setRotation(incr, math::Vector3f.UNIT_Y);

	MeshNode *duckNode = (MeshNode*)_scene.getNodeByName("Duck");
	if(duckNode)
		duckNode->getMesh()->setRotation(incr1, math::Vector3f.UNIT_Y);

	if(_pCamera)_pCamera->update();
}

void Demo::onDraw()
{
	_scene.draw(_mainRender);

	printFramerate();
}