/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <core/InputMap.h>
#include <util/Log.h>

namespace core
{
	bool InputMap::_keyPressed = false;
	InputMap::E_KEY_TYPE InputMap::_key = KT_NONE;

	InputMap *InputMap::_instance = NULL;
	void InputMap::createInstance()
	{
		TRACE("InputMap::createInstance");

		if(_instance == NULL)
			_instance = kNew(InputMap);
	}

	void InputMap::deleteInstance()
	{
		TRACE("InputMap::deleteInstance");

		if(_instance != NULL)
			kDelete(_instance);
	}

	InputMap *InputMap::getInstance()
	{
		return _instance;
	}

	void InputMap::inputKey(uint32 key)
	{
		_keyPressed = true;

		_key = (E_KEY_TYPE)key;
	}

	bool InputMap::verifyIfWasPressed(E_KEY_TYPE eKey)
	{
		if(_keyPressed)
		{
			if(eKey == _key)
			{
				_keyPressed = false;
				return true;
			}
		}

		return false;
	}
}