/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <img/Image.h>
#include <scene/Node.h>
#include <scene/property/TextureProperty.h>
#include <core/Device.h>


#include <IL/il.h>
#include <IL/ilu.h>

namespace img
{
	bool Image::openDevil()
	{
		TRACE("Image::openDevil");

		bool result = false;

		ILuint imageId;

		ilInit();

		// opengl lower coord, opposite to directx
		ilEnable(IL_ORIGIN_SET);
		ilOriginFunc(IL_ORIGIN_LOWER_LEFT); 

		ilGenImages(1, &imageId);
		ilBindImage(imageId);

		if(!ilLoadImage(_filename.getChars()))
            return false;

		ilConvertImage(IL_RGBA, IL_UNSIGNED_BYTE);

		scene::TextureProperty textureProperty;
		textureProperty.setChannels(ilGetInteger(IL_IMAGE_CHANNELS));
		textureProperty.setWidth(ilGetInteger(IL_IMAGE_WIDTH));
		textureProperty.setHeight(ilGetInteger(IL_IMAGE_HEIGHT));
		textureProperty.setFormat(ilGetInteger(IL_IMAGE_FORMAT));
		textureProperty.setTextureData(ilGetData());

		_imageId = core::Device::getRenderInstance()->setTextureProperty(&textureProperty);

		ilDeleteImages(1, &imageId); 
		ilShutDown();


		return result;
	}
}