/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <string.h>
#include <io/ByteArrayOutputStream.h>
#include <util/Assert.h>


namespace io
{
    ByteArrayOutputStream::ByteArrayOutputStream(int32 size)
    {
        assert(size > 0);
        
        _buffer.reserve(size);
    }

    ByteArrayOutputStream::~ByteArrayOutputStream()
    {
        _buffer.free();
    }

    void ByteArrayOutputStream::reset()
    {
        _buffer.free();
    }

    int32 ByteArrayOutputStream::size() const
    {
        return _buffer.getSize();
    }

    const char* ByteArrayOutputStream::toByteArray() const
    {
        // TODO: add the return

        return 0;
    }

    lang::String ByteArrayOutputStream::toNatString() const
    {
        // TODO: add the natString
        return 0;
    }

    void ByteArrayOutputStream::write(const char data)
    {
        int32 oldsize = _buffer.getSize();
        _buffer.reserve(oldsize + 1);

        _buffer.add(data);
    }

    void ByteArrayOutputStream::write(const lang::String& data)
    {
        assert(data.length() > 0);

        int32 size =  _buffer.getSize() + data.length();
        _buffer.reserve(size);

        for (uint16 i = 0; i < data.length(); i++)
            _buffer.add(data.charAt(i));
    }

    void ByteArrayOutputStream::write( const char* pData, int32 size )
    {
        assert(pData != NULL && size > 0);

        int32 oldsize = _buffer.getSize();
        _buffer.reserve( oldsize + size );

        for (int32 i = 0 ; i < size ; i++)
            _buffer.add(pData[i]);
    }

    void ByteArrayOutputStream::writeTo(OutputStream *pStreamOut)
    {
        // TODO: add the writeTo
    }

    const char * ByteArrayOutputStream::toString()
    {
        return "class: ByteArrayOutputStream";
    }
} //namespace
