/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <io/FileInputStream.h>


namespace io
{
    FileInputStream::FileInputStream()
    {
    }

    FileInputStream::~FileInputStream()
    {
        if (_fileHandle)
            fclose(_fileHandle);
    }

    bool FileInputStream::openFile(const lang::String& filename)
    {
        assert(filename.length() > 0);

        _fileHandle = fopen(filename, "rb" );
        assert(_fileHandle);

        return true;
    }

    int32 FileInputStream::read()
    {
        int32 byte = 0;
        fread(&byte, 1, 1, _fileHandle);

        return byte;
    }

    int32 FileInputStream::read(uint16 &data)
    {
        int32 byte = fread(&data, sizeof(uint16), 1, _fileHandle);

        return byte;
    }

    int32 FileInputStream::read(char *pDataOut, int32 size)
    {
        assert(pDataOut != NULL && size > 0);
        
        return fread(pDataOut, 1, size, _fileHandle );
    }

    int32 FileInputStream::available() const
    {
        int32 cur = ftell(_fileHandle);
        if(fseek(_fileHandle, 0, SEEK_END) != 0)
            return 0;

        int32 end = ftell(_fileHandle);

        if(fseek(_fileHandle, cur, SEEK_SET) != 0)
            return 0;

        if (ferror(_fileHandle))
        {
            assert(false);
        }

        return end - cur;
    }

    int32 FileInputStream::skip(int32 n)
    {
        // TODO: implement the skip
        return 0;
    }

    const char * FileInputStream::toString()
    {
        return "class: FileInputStream";
    }
} //namespace
