/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <io/FileOutputStream.h>
#include <util/Assert.h>


namespace io
{
    FileOutputStream::FileOutputStream( const lang::String& filename )
    {
        assert(filename.length() > 0);

        _fileHandle = fopen(filename, "wb" );
        assert(_fileHandle);
    }

    FileOutputStream::~FileOutputStream()
    {
        close();
    }

    void FileOutputStream::close()
    {
        if (_fileHandle)
            fclose(_fileHandle);
    }

    void FileOutputStream::write(const int32 data)
    {
        char tmp[15];
        sprintf(tmp, "%d", data);

        lang::String str(tmp);
        write(str);
    }

    void FileOutputStream::write(const char data)
    {
        fwrite(&data, 1, 1, _fileHandle);
    }

    void FileOutputStream::write(const lang::String& data)
    {
        fwrite(data, 1, data.length(), _fileHandle);
    }

    void FileOutputStream::write(const char* pData, int32 size)
    {
        fwrite(pData, 1, size, _fileHandle);
    }

    lang::String FileOutputStream::toString() const
    {
        // TODO: implement the toString
        return 0;
    }

    const char * FileOutputStream::toString()
    {
        return "class: FileOutputStream";
    }
} //namespace
