/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <scene/ColorRGBA.h>

namespace scene
{
	const ColorRGBA ColorRGBA::BLACK(0.0f,0.0f,0.0f,0.0f);
	const ColorRGBA ColorRGBA::WHITE(1.0f,1.0f,1.0f,1.0f);
	const ColorRGBA ColorRGBA::GRAY(0.5f,0.5f,0.5f,1.0f);

	ColorRGBA::ColorRGBA() :
		r(0), g(0), b(0), a(1)
	{
	}

	ColorRGBA::ColorRGBA(float32 r, float32 g, float32 b, float32 a) :
		r(r), g(g), b(b), a(a)
	{
	}
}