/* Aika
 *
 * Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */

#include <scene/Light.h>

namespace scene
{
	Light::Light() : _eType(LT_POINT), _exponent(10.0f), _cutOff(10.0f), _enabled(true)
	{
		TRACE("Light::Light");

		_translate = math::Vector3f(0.0f, 0.0f, 4.0f);
		_direction = math::Vector3f(math::Vector3f::UNIT_ZERO);

		_ambient = ColorRGBA(ColorRGBA::WHITE);
		_diffuse = ColorRGBA(1.0f, 0.0f, 0.0f, 1.0f);
		_specular = ColorRGBA(ColorRGBA::BLACK);
	}
}


