/* Aika
*
* Copyright (C) 2007, Erick Jung <erickjung@gmail.com>
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
*/

#include <stdlib.h>
#include <util/Assert.h>
#include <util/Log.h>

const char* errorTypes[] = {
        "Pointer",
        "Boolean"
};

void Assert::printError(E_ASSERT_TYPE errorType, const char* pFile, int32 line)
{
    Log::assertMsg(errorTypes[errorType], pFile, line);
    exit(-1);
}

bool Assert::assertState(const void *state, const char* pFile, int32 line)
{
    if(state == NULL)
    {
        printError(AT_POINTER, pFile, line);
    }

    return (state != NULL) ? true : false;
}

bool Assert::assertState(bool state, const char* pFile, int32 line)
{
    if(state == false)
    {
        printError(AT_BOOL, pFile, line);
    }

    return (state == true) ? true : false;
}


